
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Booking_guestsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const booking_guests = await db.booking_guests.create(
            {
                id: data.id || undefined,
        
        guest_role: data.guest_role
        ||
        null
            ,
            
        is_payer: data.is_payer
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await booking_guests.setBooking( data.booking || null, {
            transaction,
        });
        
        await booking_guests.setGuest( data.guest || null, {
            transaction,
        });
        

        

        

        return booking_guests;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const booking_guestsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                guest_role: item.guest_role
            ||
            null
            ,
            
                is_payer: item.is_payer
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const booking_guests = await db.booking_guests.bulkCreate(booking_guestsData, { transaction });

        // For each item created, replace relation files
        

        return booking_guests;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const booking_guests = await db.booking_guests.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.guest_role !== undefined) updatePayload.guest_role = data.guest_role;
        
        
        if (data.is_payer !== undefined) updatePayload.is_payer = data.is_payer;
        
        
        updatePayload.updatedById = currentUser.id;

        await booking_guests.update(updatePayload, {transaction});

        
        
        if (data.booking !== undefined) {
            await booking_guests.setBooking(
              
              data.booking,
              
              { transaction }
            );
        }
        
        if (data.guest !== undefined) {
            await booking_guests.setGuest(
              
              data.guest,
              
              { transaction }
            );
        }
        

        
        

        

        return booking_guests;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const booking_guests = await db.booking_guests.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of booking_guests) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of booking_guests) {
                await record.destroy({transaction});
            }
        });


        return booking_guests;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const booking_guests = await db.booking_guests.findByPk(id, options);

        await booking_guests.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await booking_guests.destroy({
            transaction
        });

        return booking_guests;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const booking_guests = await db.booking_guests.findOne(
            { where },
            { transaction },
        );

        if (!booking_guests) {
            return booking_guests;
        }

        const output = booking_guests.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.booking = await booking_guests.getBooking({
            transaction
        });
        
        
        output.guest = await booking_guests.getGuest({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.bookings,
        as: 'booking',
        
        where: filter.booking ? {
          [Op.or]: [
            { id: { [Op.in]: filter.booking.split('|').map(term => Utils.uuid(term)) } },
            {
              booking_code: {
                [Op.or]: filter.booking.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.guests,
        as: 'guest',
        
        where: filter.guest ? {
          [Op.or]: [
            { id: { [Op.in]: filter.guest.split('|').map(term => Utils.uuid(term)) } },
            {
              email: {
                [Op.or]: filter.guest.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.guest_role) {
                where = {
                    ...where,
                guest_role: filter.guest_role,
            };
            }
            
            if (filter.is_payer) {
                where = {
                    ...where,
                is_payer: filter.is_payer,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.booking_guests.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'booking_guests',
                        'guest_role',
                        query,
                    ),
                ],
            };
        }

        const records = await db.booking_guests.findAll({
            attributes: [ 'id', 'guest_role' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['guest_role', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.guest_role,
        }));
    }

    
};

